//---------------------------------------------------------------------------
//
// Name:        GFL_demoFrm.cpp
// Author:      Jacek
// Created:     2008-11-30 11:30:27
// Description: GFL_demoFrm class implementation
//
//---------------------------------------------------------------------------

#include "GFL_demoFrm.h"
#include "libgfl.h"
#include "libgfle.h"
//#include "libgfle.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// GFL_demoFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(GFL_demoFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(GFL_demoFrm::OnClose)
	EVT_PAINT(GFL_demoFrm::GFL_demoFrmPaint)
	EVT_MENU(ID_MNU_SEPIA_1006, GFL_demoFrm::Mnusepia1006Click)
	EVT_MENU(ID_MNU_KONTRAST_1007, GFL_demoFrm::Mnukontrast1007Click)
	EVT_MENU(ID_MNU_EMBOSS_1008, GFL_demoFrm::Mnuemboss1008Click)
	EVT_MENU(ID_MNU_RYSOWANIE_1009, GFL_demoFrm::Mnurysowanie1009Click)
	EVT_MENU(ID_MNU_EXIF_1011, GFL_demoFrm::Mnuexif1011Click)
	EVT_MENU(ID_MNU_IPTC_1012, GFL_demoFrm::Mnuiptc1012Click)
	EVT_MENU(ID_MNU_UKRYJ_1014, GFL_demoFrm::Mnuukryj1014Click)
END_EVENT_TABLE()
////Event Table End

GFL_demoFrm::GFL_demoFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	GFL_ERROR err;
    err=gflLibraryInit();
    GFL_LOAD_PARAMS load_option;
    GFL_FILE_INFORMATION file_info;
    GFL_ERROR error;
    GFL_COLOR col;

    gflGetDefaultLoadParams( &load_option );
    load_option.Flags=load_option.Flags | GFL_LOAD_METADATA;

    error=gflLoadBitmap("test.jpg", &gfl_bitmap, &load_option, &file_info );
    if (error) wxMessageBox("Nie mozna wczytac pliku");
    else
    {
        img.Create(gfl_bitmap->Width,gfl_bitmap->Height);
        for (int i=0; i<gfl_bitmap->Width; i++)
         for (int j=0; j<gfl_bitmap->Height; j++)
         {
            gflGetColorAt(gfl_bitmap,i,j,&col);
            img.SetRGB(i,j,col.Red,col.Green,col.Blue);
         }
    }
	CreateGUIControls();	
}

GFL_demoFrm::~GFL_demoFrm()
{
}

void GFL_demoFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxMemo1 = new wxTextCtrl(this, ID_WXMEMO1, wxEmptyString, wxPoint(15, 20), wxSize(242, 371), wxTE_MULTILINE, wxDefaultValidator, wxT("WxMemo1"));
	WxMemo1->SetMaxLength(0);
	WxMemo1->Show(false);
	WxMemo1->AppendText(wxT("WxMemo1"));
	WxMemo1->SetFocus();
	WxMemo1->SetInsertionPointEnd();

	WxMenuBar1 = new wxMenuBar();
	wxMenu *ID_MNU_PRZYKLADY_1005_Mnu_Obj = new wxMenu();
	ID_MNU_PRZYKLADY_1005_Mnu_Obj->Append(ID_MNU_SEPIA_1006, wxT("Sepia"), wxT(""), wxITEM_NORMAL);
	ID_MNU_PRZYKLADY_1005_Mnu_Obj->Append(ID_MNU_KONTRAST_1007, wxT("Kontrast"), wxT(""), wxITEM_NORMAL);
	ID_MNU_PRZYKLADY_1005_Mnu_Obj->Append(ID_MNU_EMBOSS_1008, wxT("Emboss"), wxT(""), wxITEM_NORMAL);
	ID_MNU_PRZYKLADY_1005_Mnu_Obj->Append(ID_MNU_RYSOWANIE_1009, wxT("Rysowanie"), wxT(""), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_PRZYKLADY_1005_Mnu_Obj, wxT("Przyklady"));
	
	wxMenu *ID_MNU_METADANE_1010_Mnu_Obj = new wxMenu();
	ID_MNU_METADANE_1010_Mnu_Obj->Append(ID_MNU_EXIF_1011, wxT("EXIF"), wxT(""), wxITEM_NORMAL);
	ID_MNU_METADANE_1010_Mnu_Obj->Append(ID_MNU_IPTC_1012, wxT("IPTC"), wxT(""), wxITEM_NORMAL);
	ID_MNU_METADANE_1010_Mnu_Obj->Append(ID_MNU_UKRYJ_1014, wxT("Ukryj"), wxT(""), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_METADANE_1010_Mnu_Obj, wxT("Metadane"));
	SetMenuBar(WxMenuBar1);

	SetTitle(wxT("GFL_demo"));
	SetIcon(wxNullIcon);
	SetSize(8,8,750,450);
	Center();
	
	////GUI Items Creation End
}

void GFL_demoFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * GFL_demoFrmPaint
 */
void GFL_demoFrm::GFL_demoFrmPaint(wxPaintEvent& event)
{
    if (!img.Ok()) return;
    wxPaintDC dc(this);   // Pobieramy kontekst okna
    wxCoord w, h;
    this->GetClientSize(&w, &h);
    wxImage img1(img);
    img1=img.Scale(w,h);
    wxBitmap bitmap(img1);           // Tworzymy tymczasowa bitmape na podstawie Img_Cpy
    dc.Clear();
    dc.DrawBitmap(bitmap, 0, 0, true);  // Rysujemy bitmape na kontekscie urzadzenia
}

/*
 * Mnusepia1006Click
 */
void GFL_demoFrm::Mnusepia1006Click(wxCommandEvent& event)
{
    GFL_COLOR col;
    gflSepia(gfl_bitmap,&gfl_bitmap,50);
    for (int i=0; i<gfl_bitmap->Width; i++)
        for (int j=0; j<gfl_bitmap->Height; j++)
        {
            gflGetColorAt(gfl_bitmap,i,j,&col);
            img.SetRGB(i,j,col.Red,col.Green,col.Blue);
        }
        Refresh();
}

/*
 * Mnukontrast1007Click
 */
void GFL_demoFrm::Mnukontrast1007Click(wxCommandEvent& event)
{
    GFL_COLOR col;
    gflContrast(gfl_bitmap,&gfl_bitmap,50);
    img.Create(gfl_bitmap->Width,gfl_bitmap->Height);
    for (int i=0; i<gfl_bitmap->Width; i++)
        for (int j=0; j<gfl_bitmap->Height; j++)
        {
            gflGetColorAt(gfl_bitmap,i,j,&col);
            img.SetRGB(i,j,col.Red,col.Green,col.Blue);
        }
        Refresh();
}

/*
 * Mnuemboss1008Click
 */
void GFL_demoFrm::Mnuemboss1008Click(wxCommandEvent& event)
{
    GFL_COLOR col;
    gflEmboss(gfl_bitmap,&gfl_bitmap);
    img.Create(gfl_bitmap->Width,gfl_bitmap->Height);
    for (int i=0; i<gfl_bitmap->Width; i++)
        for (int j=0; j<gfl_bitmap->Height; j++)
        {
            gflGetColorAt(gfl_bitmap,i,j,&col);
            img.SetRGB(i,j,col.Red,col.Green,col.Blue);
        }
    Refresh();
}

/*
 * Mnurysowanie1009Click
 */
void GFL_demoFrm::Mnurysowanie1009Click(wxCommandEvent& event)
{
    GFL_COLOR col;
    GFL_COLOR gfl_BLUE={0,0,255,0};
    GFL_COLOR gfl_GREEN={0,255,0,0};
    gflDrawCircleColor(gfl_bitmap,150,150,80,&gfl_BLUE,4,&gfl_GREEN,GFL_LINE_STYLE_SOLID,&gfl_bitmap);
    img.Create(gfl_bitmap->Width,gfl_bitmap->Height);
    for (int i=0; i<gfl_bitmap->Width; i++)
        for (int j=0; j<gfl_bitmap->Height; j++)
        {
            gflGetColorAt(gfl_bitmap,i,j,&col);
            img.SetRGB(i,j,col.Red,col.Green,col.Blue);
        }
    Refresh();
}

/*
 * Mnuexif1011Click
 */
void GFL_demoFrm::Mnuexif1011Click(wxCommandEvent& event)
{
    WxMemo1->Show();
    WxMemo1->Clear();
    (*WxMemo1) << "Metadane: EXIF" << "\n";
    wxString s;
    GFL_EXIF_DATA *exif_data;
    if (gflBitmapHasEXIF(gfl_bitmap)!=GFL_TRUE) wxMessageBox("Plik nie zawiera informacji EXIF");
    else
    {
        exif_data=gflBitmapGetEXIF(gfl_bitmap,NULL);
        for (int i=0; i<exif_data->NumberOfItems; i++)
        {
            s=exif_data->ItemsList[i].Name;
            s+=" : ";
            s+=exif_data->ItemsList[i].Value;
            (*WxMemo1) << s << "\n";
        }
    }
}

/*
 * Mnuiptc1012Click
 */
void GFL_demoFrm::Mnuiptc1012Click(wxCommandEvent& event)
{
    WxMemo1->Show();
    WxMemo1->Clear();
    (*WxMemo1) << "Metadane: IPTC" << "\n";
    
    wxString s;
    GFL_IPTC_DATA *iptc_data;
    if (gflBitmapHasIPTC(gfl_bitmap)!=GFL_TRUE) wxMessageBox("Plik nie zawiera informacji IPTC");
    else
    {
    iptc_data=gflBitmapGetIPTC(gfl_bitmap);
        for (int i=0; i<iptc_data->NumberOfItems; i++)
        {
            s=iptc_data->ItemsList[i].Name;
            s+=" : ";
            s+=iptc_data->ItemsList[i].Value;
            (*WxMemo1) << s << "\n";
        }
    }
}

/*
 * Mnuukryj1014Click
 */
void GFL_demoFrm::Mnuukryj1014Click(wxCommandEvent& event)
{
    WxMemo1->Hide();
}
